unit TermTester;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TTester = class(TForm)
    EditTerm: TLabeledEdit;
    Ausgabe: TListBox;
    Teste: TButton;
    PROCEDURE P1;
    PROCEDURE P2;
    procedure TesteClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var Tester: TTester;

implementation

{$R *.dfm}
 VAR I,L:Integer; TERM:STRING; TEST,OK:BOOLEAN;

 PROCEDURE TTester.P1;
  Var OkStr,TestStr:String;
  BEGIN
   if Ok then OkStr:='True' else OkStr:='False';
   if Test then TestStr:='True' else TestStr:='False';
   INC(I);Ausgabe.Items.Add('P1: '+Format('%4s %9d %6d %8s %7s',[TERM[I],I,L,OkStr,TestStr]));
   IF TERM[I]='(' THEN BEGIN INC(L);P1 END;
   IF NOT(TERM[I] IN['a'..'z','A'..'Z']) THEN TEST:=FALSE;
   IF (TERM[I]=';') AND (L=0) THEN OK:=TRUE
  END;

 PROCEDURE TTester.P2;
  Var OkStr,TestStr:String;
  BEGIN
   if Ok then OkStr:='True' else OkStr:='False';
   if Test then TestStr:='True' else TestStr:='False';
   INC(I);Ausgabe.Items.Add('P2: '+Format('%4s %9d %6d %8s %7s',[TERM[I],I,L,OkStr,TestStr]));
   IF TERM[I] IN[')',';','+','*','-','/'] THEN
    BEGIN
     IF (TERM[I]=';') AND (L>0) THEN TEST:=FALSE;
     IF (TERM[I]=';') AND (L=0) THEN OK:=TRUE;
     IF TERM[I]=')' THEN BEGIN DEC(L);P2 END;
     IF TERM[I] IN['+','*','-','/'] THEN BEGIN P1;P2 END
    END
   ELSE TEST:=FALSE
  END;

 procedure TTester.TesteClick(Sender: TObject);
  var OkStr,TestStr:String;
  begin
   I:=0;L:=0;TEST:=TRUE;OK:=FALSE;Ausgabe.Clear;
   TERM:=EditTerm.Text+';';
   Ausgabe.Items.Add('Dein Term : '+Term);
   Ausgabe.Items.Add('Wo'+Format('%9s %6s %6s %6s %9s',['Zeichen','I','L','Ok','Test']));
   Ausgabe.Items.Add('___'+Format('%8s %6s %6s %8s %7s',['_______','_','_','_____','_____']));
   REPEAT P1;P2 UNTIL (NOT TEST) OR OK;
   if Ok then OkStr:='True' else OkStr:='False';
   if Test then TestStr:='True' else TestStr:='False';
   Ausgabe.Items.Add(Format('%25d %8s %7s',[L,OkStr,TestStr]));
   IF OK AND TEST THEN Ausgabe.Items.Add('Term ist i.O.')
   ELSE Ausgabe.Items.Add('Syntaxerror an Position '+IntToStr(I-1)+'!');
  end;

end.
